// copyright 2002 Josh Levenberg, please see copying.txt
/*
  The main loop of the application.
  Sorry this is such a large ugly mess.
*/
#include <stdlib.h>
#include <stdio.h>
#include "dlod.h"
#include "hf.h"
#include "os.h"
#include "pngwrap.h"
#include "model.h"
#include "glinit.h"
#include "screencap.h"
#include "uitype.h"
#include "dispmeth.h"

/*
  To do: support text titles
  support glut game mode
  better color?
  better culling
*/

vec_t gAvatarHeight=0.2f;

vec3_t gAvatar = {0.5f, 0.5f, HEIGHT_FIELD_MAX_HEIGHT/2 };

FILE *gOutFile=0;

camera_t gCamera[numCameras] = {
      {{0.0f, 0.0f, 0.0f},  {1.0f, 0.0f, 0.0f}, 45.0f },
      {{0.5f, 0.5f, 30.0f}, {0.5f, 0.5f, 0.0f}, 1.25f },
      {{0.5f, 0.5f, 30.0f}, {0.5f, 0.5f, 0.0f}, 1.9f }
  };

int gWhichCamera=0;
bool gPaused=false;
int gWireframe=0;
int gDoCulling=14;

int gWidth=640, gHeight=480;
bool gFullScreen=false;
int gSavedWidth, gSavedHeight;

unsigned gStartTime;
unsigned gNumFrames=0;
double gBandwidth=0;
double gNumOutputTris=0;

// end globals

// static heightfield data

static float *sHeightField;
static int sHeightFieldShift;
static int sHeightFieldSize;
static std::auto_array<char> sHeightFilename;
static char *sLandscapeFilename=0;
static vec_t sHeightFieldHeight=HEIGHT_FIELD_MAX_HEIGHT;

void SimulateKeys(const char *str);

void DummyFunction()
  {
  }

static bool FileExists(const char * filename)
  {
    FILE *filehandle = fopen(filename, "r");
    if (filehandle)
      {
        fclose(filehandle);
        return true;
      }
    return false;
  }

const char *FindFile(const char *filename)
  {
    static char buffer[256];
    if (FileExists(filename))
      return filename;
    strcpy(buffer, "..\\");
    strcat(buffer, filename);
    if (FileExists(buffer))
      return buffer;
    printf("File not found: %s\n", filename);
    return 0;
  }

void DrawFunction()
  {
#ifdef DEMO_MOVIE
    if (! UIPreDraw())
#else
    if (gWhichCamera)
      glClearColor(1.0f, 1.0f, 1.0f, 0.5f);
    else
      glClearColor(0.4f, 0.6f, 1.0f, 0.5f);
      
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
#endif
#if 0 // can't get this to work!
    if (gCurrentDisplay >= 0)
      {
        // Draw a heading
        glAlphaFunc(GL_GEQUAL, 0.0625);
        glEnable(GL_ALPHA_TEST);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        gluLookAt(0,0,0, // eye point
                  0,0,-1, // center point
                  0,1,0);// up vector

        glBindTexture (GL_TEXTURE_2D, 2);
        glColor3f(1,1,1);
        glBegin (GL_QUADS);
        glTexCoord2f(1.0, 0.5+0.5*gCurrentDisplay); glVertex3f( 0.1, 0.1, -0.5);
        glTexCoord2f(1.0, 0.5*gCurrentDisplay);     glVertex3f( 0.1, 0.2, -0.5);
        glTexCoord2f(0.0, 0.5*gCurrentDisplay);     glVertex3f(-0.1, 0.2, -0.5);
        glTexCoord2f(0.0, 0.5+0.5*gCurrentDisplay); glVertex3f(-0.1, 0.1, -0.5);
        glEnd ();

        glDisable(GL_BLEND);
        glDisable(GL_ALPHA_TEST);
        glBindTexture(GL_TEXTURE_2D, 1); // Restore 
      }
    else 
#endif
    if (gCurrentDisplay>=0 && gDisplayMethods[gCurrentDisplay].draw)
      {
        gDisplayMethods[gCurrentDisplay].draw();
        ++gNumFrames;
      }
#ifdef DEMO_MOVIE
    // if (gCurrentDisplay>=0 && gDisplayMethods[gCurrentDisplay].draw && gText) DRAW TEXT;
#endif
    glutSwapBuffers();
    UIPostDraw();
  }

void PrintStats()
  {
    unsigned totalTime=GetTimeInMS()-gStartTime;

    if (gCurrentDisplay>=0 && gDisplayMethods[gCurrentDisplay].printstats)
      gDisplayMethods[gCurrentDisplay].printstats();
    
    fprintf(gOutFile, "%d frames in %dms = %.2f frames/second, %.2f triangles/frame\n"
                      "%d bytes of bandwidth/frame\n", 
            gNumFrames, totalTime, (gNumFrames*1000./totalTime), ((double)gNumOutputTris)/gNumFrames,
            (unsigned) (gBandwidth/gNumFrames));
    fflush(gOutFile);
  }

void ResetStats()
  {
    if (gCurrentDisplay>=0 && gDisplayMethods[gCurrentDisplay].resetstats)
      gDisplayMethods[gCurrentDisplay].resetstats();
    
    gNumFrames=0;
    gNumOutputTris=0;
    gBandwidth=0;
    gStartTime=GetTimeInMS();
  }

void SimulateKeys(const char *str)
  {
    if (gCurrentDisplay>=0 && gDisplayMethods[gCurrentDisplay].keyboard)
      while (*str)
        {
          gDisplayMethods[gCurrentDisplay].keyboard(*str, 0, 0);
          ++str;
        }
    else
      while (*str)
        {
          DefaultKeyboard(*str, 0, 0);
          ++str;
        }
  }

void Quit()
  {
    SwitchToDisplay(-1);
    fclose(gOutFile);
    gOutFile=0;
    exit(0);
  }

// -----

void glutResize(int width, int height)
  {   
    gWidth=width;
    gHeight=height;
    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (gWhichCamera)
      gluPerspective(gCamera[gWhichCamera].mFov, (float)gWidth/(float)gHeight, 10.0, 40.0);
    else
      gluPerspective(gCamera[gWhichCamera].mFov, (float)gWidth/(float)gHeight, 0.001, 1.5);
    glMatrixMode(GL_MODELVIEW);
  }

static int LoadHeightField(std::auto_array<unsigned short> & hf)
  {
    int width, height;
    unsigned short *ptr;
    bool result=read_png_16gray(sHeightFilename.get(), &width, &height, &ptr);
    if (! result)
      {
        printf("Error reading %s", sHeightFilename);
        exit(1);
      }
    if (width!=height)
      {
        printf("%s not square (%d x %d)", sHeightFilename, width, height);
        exit(1);
      }
    int shift=0;
    while (1<<shift)
      {
        if ((1<<shift)+1==width)
          break;
        ++shift;
      }
    if (! (1<<shift))
      {
        printf("%s not (2^n)+1 x (2^n)+1 (%d x %d)", sHeightFilename, width, height);
        exit(1);
      }
    hf.reset(ptr);
    return shift;
  }

static void Initialize()
  {
    printf("Loading height field %s.\n", sHeightFilename);

    /* clear the screen */
    glClearColor(0.0f, 0.0f, 0.0f, 0.5f);
    glClear(GL_COLOR_BUFFER_BIT);
    glutSwapBuffers();

    std::auto_array<unsigned short> hf;
    sHeightFieldShift=LoadHeightField(hf);
    sHeightFieldSize=1<<sHeightFieldShift;

    sHeightField = new float[(sHeightFieldSize+1)*(sHeightFieldSize+1)];
    for (int i=0; i<(sHeightFieldSize+1)*(sHeightFieldSize+1); ++i)
      sHeightField[i]=hf[i]*(65535/sHeightFieldHeight);

    if (sLandscapeFilename)
      LoadLandscapeTexture(sLandscapeFilename);
    else
      GenerateTextureMap(sHeightFieldSize, sHeightField);

    BindLandscapeTexture();

      {
        /*
        vec3_t light_dir={1,1,1};
        vec_t light_cos = cos(.01);
        vec_t light_fraction = (1.0-((double)light_cos)*light_cos);
        vec3_t light_clr={1./light_fraction,.95/light_fraction,.8/light_fraction};
        vec3_t sky_clr={.1,.2,.3};

        GenerateTextureMap_GlobalIllumination(light_dir, light_clr, light_cos, 
                                              sky_clr, 0, 10);
        */
      
        glClearColor(0.4f, 0.6f, 1.0f, 0.5f);
        //glClearColor(1.0f, 1.0f, 1.0f, 0.5f);
      }

    delete[] sHeightField;
    sHeightField=0;

    glBindTexture(GL_TEXTURE_2D, 1);

    InitializeModel(hf, sHeightFieldHeight, sHeightFieldShift);

    printf("Pre-computing error metric\n");
    InitializeErrors(ErrorRatio);

    glutIdle();
  }

void DefaultKeyboard(unsigned char key, int x, int y)
  {
    UIKey(key);
    switch (key)
      {

        case 'a':
        case 'A':
          gAvatarHeight+=(0.003/HEIGHT_FIELD_MAX_HEIGHT)*sHeightFieldHeight;
          break;

        case 'z':
        case 'Z':
          gAvatarHeight-=(0.003/HEIGHT_FIELD_MAX_HEIGHT)*sHeightFieldHeight;
          break;

        case '[':
          ScreenBWCapture();
          break;

        case 27: // esc
        case 'q':
        case 'Q':
          // quit
          Quit();

        case 's':
        case 'S':
          // status
          {
            GLenum err=glGetError();
            if (err!=GL_NO_ERROR)
              fprintf(gOutFile, "0x%x error returned\n", err);
            PrintStats();
            ResetStats();
          }
          break;


        case '+':
          // zoom in
          gCamera[gWhichCamera].mFov *= 0.95;
          glutResize(gWidth, gHeight);
          break;

        case '-':
          // zoom out
          gCamera[gWhichCamera].mFov /= 0.95;
          glutResize(gWidth, gHeight);
          break;

        case '1':
        case '2':
        case '3':
          // switch cameras
          gWhichCamera = key-'1';
          glutResize(gWidth, gHeight);
          break;

        case 'p':
        case 'P':
          // pause/unpause
          gPaused = !gPaused;
          break;

        case 'w':
        case 'W':
          // wireframe mode
          gWireframe=(gWireframe+1)%4;
          break;

        case 'f':
        case 'F':
          // toggle fullscreen mode
          gFullScreen= !gFullScreen;
          if (gFullScreen)
            {
              gSavedWidth=gWidth;
              gSavedHeight=gHeight;
              glutFullScreen();
            }
          else
            glutReshapeWindow(gSavedWidth,gSavedHeight);
          break;

        case 'd':
        case 'D':
          // modify draw technique
          SwitchToDisplay((gCurrentDisplay+1) % NumDisplayMethods);
          break;

        case 'c':
        case 'C':
          { // toggle culling
            if (key=='c')
              {
                --gDoCulling;
                if (gDoCulling<0)
                  gDoCulling=30;
              }
            else
              {
                ++gDoCulling;
                if (gDoCulling>30)
                  gDoCulling=0;
              }
            fprintf(gOutFile, "Culling turned %s (level=%d)\n", gDoCulling ? "on" : "off", gDoCulling);
            break;
          }
      }
  }

int main(int argc, char *argv[])
  {
    gOutFile=fopen("output.txt", "a+t");
    if (! gOutFile)
      {
        printf("Could not open output.txt\n");
        return 1;
      }
    fprintf(gOutFile, "\n-----------V4.0-------------\n");
    
    if (argc>1)
      {
        sHeightFilename.reset(new char[strlen(argv[1])+1]);
        strcpy(sHeightFilename.get(), argv[1]);
        --argc;
        ++argv;
      }
    else
      {
        sHeightFilename.reset(new char[12]);
        strcpy(sHeightFilename.get(), "def_hf.png");
      }

    if (argc>1)
      {
        sLandscapeFilename=argv[1];
        --argc;
        ++argv;
      }
    else
      sLandscapeFilename=0;

    sHeightFieldHeight=HEIGHT_FIELD_MAX_HEIGHT;
    if (argc>1)
      {
        vec_t new_height=atof(argv[1]);
        if (new_height>0)
          {
            sHeightFieldHeight=new_height;
            --argc;
            ++argv;
          }
      }
    gAvatarHeight *= sHeightFieldHeight;

    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
    glutInitWindowSize(gWidth, gHeight);
    glutInitWindowPosition(100, 100);
    glutCreateWindow("Dynamic LOD Test");

    glutReshapeFunc(glutResize);
    glutIdleFunc(glutIdle);
    glutDisplayFunc(DrawFunction);
    UIInit();

    InitGL();

    Initialize();

    InitDisplayMethods();

    GLenum err=glGetError();
    if (err!=GL_NO_ERROR)
      fprintf(gOutFile, "0x%x error returned\n", err);

    printf("Esc, Q  Quit               "
           "S       Status             \n"
           "+/-     Zoom in/out        "
           "1-3     Camera             \n"
           "P       Pause              "
           "W       Wireframe          \n"
           "D       Draw method        "
           "F       Full screen        \n"
           "A/Z     Up/Down            "
           "[       Screen capture     \n");

    gStartTime=GetTimeInMS();
    glutMainLoop();

    SwitchToDisplay(-1);

    return 0;
  }
