// copyright 2002 Josh Levenberg, please see copying.txt
#include "assert.h"
#include "jstring.h"
#include <windows.h>
#include <stdlib.h>

namespace Assert
  {
    static void PasteToClipboard(const char *str)
      {
        // Paste it to clipboard:
        if (OpenClipboard(NULL))
          {
            HGLOBAL hMem;
            char *pMem;

            hMem = GlobalAlloc(GHND|GMEM_DDESHARE, strlen(str)+1);
            if (hMem)
              {
                pMem = (char*)GlobalLock(hMem);
                strcpy(pMem, str);
                GlobalUnlock(hMem);

                EmptyClipboard();
                SetClipboardData(CF_TEXT, hMem);
              }

            CloseClipboard();
            GlobalFree(hMem);
          }
      }

    AssertResult DefaultAssertFunction(const char *file, unsigned line, const char *expr)
      {
        string str("Assertion failed: file: ");
        char buf[33];
        str += file;
        str += " line: ";
        str += itoa(line, buf, 10);
        str += " expression: ";
        str += expr;
        PasteToClipboard(str.c_str());
        OutputDebugString(str.c_str());
        return Break;
      }

    AssertFunction gAssertFunction=DefaultAssertFunction;
  };
